package betterwithmods.module.hardcore.world.villagers;

import net.minecraft.entity.IMerchant;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.*;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

public class ContainerVillager extends Container {
    /**
     * Instance of Merchant.
     */
    private final IMerchant merchant;
    private final InventoryMerchant merchantInventory;
    /**
     * Instance of World.
     */
    private final World world;

    public ContainerVillager(InventoryPlayer playerInventory, IMerchant merchant, World worldIn) {
        this.merchant = merchant;
        this.world = worldIn;
        this.merchantInventory = new InventoryMerchant(playerInventory.field_70458_d, merchant);
        this.func_75146_a(new Slot(this.merchantInventory, 0, 36, 53));
        this.func_75146_a(new Slot(this.merchantInventory, 1, 62, 53));
        this.func_75146_a(new SlotMerchantResult(playerInventory.field_70458_d, merchant, this.merchantInventory, 2, 120, 53));

        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 9; ++j) {
                this.func_75146_a(new Slot(playerInventory, j + i * 9 + 9, 8 + j * 18, 84 + i * 18));
            }
        }

        for (int k = 0; k < 9; ++k) {
            this.func_75146_a(new Slot(playerInventory, k, 8 + k * 18, 142));
        }
    }

    public InventoryMerchant getMerchantInventory() {
        return this.merchantInventory;
    }

    /**
     * Callback for when the crafting matrix is changed.
     */
    public void func_75130_a(IInventory inventoryIn) {
        this.merchantInventory.func_70470_g();
        super.func_75130_a(inventoryIn);
    }

    public void setCurrentRecipeIndex(int currentRecipeIndex) {
        this.merchantInventory.func_70471_c(currentRecipeIndex);
    }

    /**
     * Determines whether supplied player can use this container
     */
    public boolean func_75145_c(EntityPlayer playerIn) {
        return this.merchant.func_70931_l_() == playerIn;
    }

    /**
     * Handle when the stack in slot {@code index} is shift-clicked. Normally this moves the stack between the player
     * inventory and the other inventory(s).
     */
    public ItemStack func_82846_b(EntityPlayer playerIn, int index) {
        ItemStack itemstack = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(index);

        if (slot != null && slot.func_75216_d()) {
            ItemStack itemstack1 = slot.func_75211_c();
            itemstack = itemstack1.func_77946_l();

            if (index == 2) {
                if (!this.func_75135_a(itemstack1, 3, 39, true)) {
                    return ItemStack.field_190927_a;
                }

                slot.func_75220_a(itemstack1, itemstack);
            } else if (index != 0 && index != 1) {
                if (index < 30) {
                    if (!this.func_75135_a(itemstack1, 30, 39, false)) {
                        return ItemStack.field_190927_a;
                    }
                } else if (index < 39 && !this.func_75135_a(itemstack1, 3, 30, false)) {
                    return ItemStack.field_190927_a;
                }
            } else if (!this.func_75135_a(itemstack1, 3, 39, false)) {
                return ItemStack.field_190927_a;
            }

            if (itemstack1.func_190926_b()) {
                slot.func_75215_d(ItemStack.field_190927_a);
            } else {
                slot.func_75218_e();
            }

            if (itemstack1.func_190916_E() == itemstack.func_190916_E()) {
                return ItemStack.field_190927_a;
            }

            slot.func_190901_a(playerIn, itemstack1);
        }

        return itemstack;
    }

    /**
     * Called when the container is closed.
     */
    public void func_75134_a(EntityPlayer playerIn) {
        super.func_75134_a(playerIn);
        this.merchant.func_70932_a_(null);
        super.func_75134_a(playerIn);

        if (!this.world.field_72995_K) {
            ItemStack itemstack = this.merchantInventory.func_70304_b(0);

            if (!itemstack.func_190926_b()) {
                playerIn.func_71019_a(itemstack, false);
            }

            itemstack = this.merchantInventory.func_70304_b(1);

            if (!itemstack.func_190926_b()) {
                playerIn.func_71019_a(itemstack, false);
            }
        }
    }
}
